<?php
/*
Plugin Name: Sequential
Plugin URI: http://plugins.thefoundation.com
Description: Upload a bunch of pics and see them next to each other.
Version: 1.00
Author: Wok
Author URI: http://thefoundationthemes.com
License: APL2
*/



/**************************************************************
 FOUNDATION GALLERY - SHORT CODE
**************************************************************/
add_shortcode('gallery', 'foundation_gallery_shortcodehandler');
function foundation_gallery_shortcodehandler($atts, $content = null) {
	global $post;

	$atts = shortcode_atts(array(
		'querytype' => 'attachment',
		'targetid' => $post->ID,
		'imagesize' => 'fullsize',
		'thumbnavsize' => 'minimedium',			
		'enablethumbpreview' => true,
		'enablenextprev' => false,
		'orderby' => 'menu_order'	
	), $atts);

	$gallery = get_foundation_gallery( $atts );
	return $gallery.$content;
}

/**************************************************************
 FOUNDATION GALLERY - ECHO FUNCTION
**************************************************************/
function foundation_gallery( $atts = null) {
	global $post;
	echo get_foundation_gallery( $atts);
}

/**************************************************************
 FOUNDATION GALLERY - XHTML WRAPPER FUNCTION
**************************************************************/
function get_foundation_gallery( $atts = null ) {
		global $wp_query, $post, $paged;
	
			$return = foundation_gallery_extractMedia( $atts );

		return $return;
}

/**************************************************************
 THEFOUNDATION GALLERY
**************************************************************/
function foundation_gallery_extractMedia( $atts = null ){
		global $wp_query, $post, $paged, $post_count;

		$defaults = array (
			'targetid' => $post->ID,
			'querytype' => 'attachment',		
			'imagesize' => 'thumbnail',
			'enable_title' => false,
			'hyperlink_target' => 'linktoself',
			'hyperlink_enable' => false,
			'hyperlink_placement' => 'title'			
		);
		$atts = wp_parse_args( $atts, $defaults );
		extract( $atts, EXTR_SKIP );			
		$query_args = build_query_array($atts);	
		
		$temp = $wp_query;
		$wp_query= null;	

		$wp_query = new WP_Query();
		$wp_query->query($query_args);
					
				
		while ($wp_query->have_posts()) : $wp_query->the_post();
			$image = retrieve_media( $querytype, $imagesize, $hyperlink_target, $hyperlink_enable );			
			$caption = retrieve_content('post_excerpt');
			$caption = xtag( 'div', $caption, 'class=wp-caption');
			
			$outputslide .= $image.$caption;
		endwhile;

		$outputslide = xtag( 'div', $outputslide, "class=thefoundation-gallery");

		$wp_query = null; $wp_query = $temp;
		wp_reset_query();
		return $outputslide;

}








/******************************
[TT] - SELECT CONTENT TO RETURN
 ******************************/
function retrieve_content($type = "content")
{
    global $wp_query, $post, $paged, $post_count;

    switch ($type) {
        case "":
            $content = "";
            break;
        case false:
            $content = "";
            break;
        case "post_excerpt":
            $content = $post->post_excerpt;
            break;
        case "post_content":
            $content = $post->post_content;
            break;
        case "the_excerpt":
            $content = get_the_excerpt();
            break;
        case "the_excerpt_filtered":
            $content = apply_filters('the_excerpt', get_the_excerpt());
            break;
        case "the_content";
            $content = get_the_content();
        case "the_content_filtered";
            $content = apply_filters('the_content', get_the_content());
            break;
        default:
            $content = get_the_content();
    }

    return $content;

}




/**
 * CONSTRUCT XHTML TAGS USING A FUNCTION, $ARS IS A QUERY STRING
 *
 * THAT WILL BE EXTRACTED.
 * @param string $tag
 * @param $content
 * @param null $args
 * @param string $precontent
 * @param string $postcontent
 * @return bool|string
 */
function xtag($tag = "div", $content, $args = null, $precontent = "", $postcontent = "")
{

    if ($tag) {

        //	GET XHTML ELEMENT ATTRIBUTES
        $defaults = array(
            'id' => "",
            'class' => "",
            'href' => "",
            'title' => "",
            'rel' => "",
            'target' => ""
        );
        $args = wp_parse_args($args, $defaults);
        extract($args, EXTR_SKIP);


        if ($content == "") :
            return false;
        endif;

        $divxhmtl = "";
        if ($id != "") :
            $id = ' id="' . $id . '"';
        endif;

        if ($class != "") :
            $class = ' class="' . $class . '"';
        endif;

        if ($href != "") :
            $href = ' href="' . $href . '"';
        endif;

        if ($title != "") :
            $title = ' title="' . $title . '"';
        endif;

        if ($rel != "") :
            $rel = ' rel="' . $rel . '"';
        endif;

        if ($target != "") :
            $target = ' target="' . $target . '"';
        endif;


        if ($content != "") :
            $divxhtml = "\n" . '<' . $tag . $id . $class . $href . $title . $rel . $target . '>';
            $divxhtml .= "\n\t" . $precontent . $content . $postcontent;
            $divxhtml .= "\n" . "</$tag>";
        endif;


        return $divxhtml;
    } else {
        return $content;
    }
}





function retrieve_media($querytype = "default", $imagesize = "thumbnail", $hyperlink_target = false, $hyperlink_enable = false, $hyperlink_imagesize = null)
{

    global $wp_query, $post, $paged, $post_count;


    // IMAGE RETRIEVAL FUNCTION IS BASED ON TYPE OF QUERY
    switch ($querytype) {
        case false:
            $image = "";
            break;
        case "attachment": // THE QUERY OBJECT CONTAINS MEDIA ATTACHMENTS
            $image = wp_get_attachment_image($post->ID, $imagesize, false);
            break;
        default:
            $indexpos = 0;
            if (has_post_thumbnail($post->ID)) {
                // the current post has a thumbnail
                $image = get_the_post_thumbnail($post->ID, $imagesize);
            } else {
                $image = get_first_image($post->ID, $imagesize, $indexpos);
            }
    }

    if (is_null($hyperlink_imagesize)) :
        $hyperlink_imagesize = $imagesize;
    endif;

    switch ($hyperlink_target) {
        case "link_to_file" :
            $imagesrc = wp_get_attachment_image_src($post->ID, $hyperlink_imagesize, false);
            $href = $imagesrc[0];
            if ($href == "")
                $href = get_permalink($post->ID);
            break;
        case "link_to_attachment_page" :
            if ($post->post_type != 'attachment') :
                $href = get_first_image_attachment_link($post->ID);
            else:
                $href = get_attachment_link($post->ID);
            endif;
            break;
        case "link_to_parent" :
            if ($post->post_parent != '') :
                $href = get_permalink($post->post_parent);
            else :
                $href = get_permalink($post->ID);
            endif;
            break;
        default:
            // DO NOTHING
    }

    if ($hyperlink_enable) {
        $image = xtag("a", $image, "href=" . $href . "&title=" . $post->post_title);
    }

    return $image;


}


/********************************************************
GET FIRST FUNCTIONS
 ********************************************************/
function get_first_image($post_ID, $size = "thumbnail", $num = 0)
{
    $thumbargs = array(
        'post_type' => 'attachment',
        'post_mime_type' => 'image',
        'post_status' => null,
        'post_parent' => $post_ID,
        'orderby' => 'menu_order',
        'order' => 'ASC'
    );
    $thumbs = get_posts($thumbargs);
    if ($thumbs) {
        return wp_get_attachment_image($thumbs[$num]->ID, $size, false);
    } else {
        return false;
    }
}


function build_query_array($atts)
{
    global $post;

    // http://codex.wordpress.org/Function_Reference/query_posts
    $default = array(
        'targetid' => $post->ID,
        'querytype' => 'default',
    );

    $atts = wp_parse_args($atts, $default);
    extract($atts, EXTR_SKIP);

    switch ($querytype) {
        case "attachment":
            $query = array(
                'post_parent' => $targetid,
                'post_status' => 'null',
                'post_type' => 'attachment',
                'order' => 'ASC',
                'orderby' => 'menu_order',
                'showposts' => '100',
                'post_mime_type' => 'image/jpeg,image/gif,image/jpg,image/png'
            );
            break;
        case "category":
            $query = array(
                'category_name' => $category,
                'post_status' => 'publish',
                'order' => 'ASC',
                'orderby' => 'menu_order',
                'showposts' => '100',
            );
            break;
        case "tag":
            $query = array(
                "tag" => $tag,
                'post_status' => 'publish',
                'order' => 'ASC',
                'orderby' => 'menu_order',
                'showposts' => '100',
            );
            break;
        case "posttype":
            $query = array(
                'post_type' => $post_type,
                'post_status' => 'publish',
                'order' => 'ASC',
                'orderby' => 'menu_order',
                'showposts' => '100',
            );
            break;
        case "posttype_category":
            $query = array(
                $category . '_category' => 'video',
                'post_status' => 'publish',
                'order' => 'ASC',
                'orderby' => 'menu_order',
                'showposts' => '100',
            );
            break;
        case "related_by_term":
            # [12.15.2010]	http://codesnipp.it/code/1403
            $query = array(
                'tag__in' => $tag_in_array,
                'post__not_in' => $post_not_in_array,
                'showposts' => 1,
                'caller_get_posts' => 1
            );
            break;
        case "term":
            $query = array(
                $termname => $term
            );
            break;
        default:
            $query = array(
                'post_type' => 'post',
                'post_status' => 'publish',
                'showposts' => 0,
            );
    }


    /***
    shortcode_atts() to filter out non query variables
    The first paramter is array of accepted vars
     ***/
    $query = shortcode_atts($query, $atts);

    return $query;

}

?>